searchData={"content_type":"text/markdown","items":[{"doc":"Common data frame analytics functions.","ref":"Coda.Analytics.Commons.html","title":"Coda.Analytics.Commons","type":"module"},{"doc":"Compute count and frequency for a columns subset.\n\nOptions:\n- `filter` - an `Explorer.DataFrame` filter function that excludes data in analytics\n- `counts` - includes only facets with this counts (integer)\n- `sort` - by `:counts` or `:freq` (frequencies over the years)","ref":"Coda.Analytics.Commons.html#frequencies/3","title":"Coda.Analytics.Commons.frequencies/3","type":"function"},{"doc":"Rank data frame by counts or (year) frequency, limits to nth rows.","ref":"Coda.Analytics.Commons.html#rank_and_limit/2","title":"Coda.Analytics.Commons.rank_and_limit/2","type":"function"},{"doc":"","ref":"Coda.Analytics.Commons.html#t:dataframe/0","title":"Coda.Analytics.Commons.dataframe/0","type":"type"},{"doc":"","ref":"Coda.Analytics.Commons.html#t:facet_type/0","title":"Coda.Analytics.Commons.facet_type/0","type":"type"},{"doc":"Create on this day analytics for various facets","ref":"Coda.Analytics.OnThisDay.html","title":"Coda.Analytics.OnThisDay","type":"module"},{"doc":"","ref":"Coda.Analytics.OnThisDay.html#columns/0","title":"Coda.Analytics.OnThisDay.columns/0","type":"function"},{"doc":"Behaviour of facets analytics","ref":"Coda.Behaviour.Analytics.html","title":"Coda.Behaviour.Analytics","type":"behaviour"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#c:dataframe/1","title":"Coda.Behaviour.Analytics.dataframe/1","type":"callback"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#c:digest/1","title":"Coda.Behaviour.Analytics.digest/1","type":"callback"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#c:sample_albums/2","title":"Coda.Behaviour.Analytics.sample_albums/2","type":"callback"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#c:sample_artists/2","title":"Coda.Behaviour.Analytics.sample_artists/2","type":"callback"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#c:sample_tracks/2","title":"Coda.Behaviour.Analytics.sample_tracks/2","type":"callback"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#c:top_albums/2","title":"Coda.Behaviour.Analytics.top_albums/2","type":"callback"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#c:top_artists/2","title":"Coda.Behaviour.Analytics.top_artists/2","type":"callback"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#c:top_tracks/2","title":"Coda.Behaviour.Analytics.top_tracks/2","type":"callback"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#t:dataframe/0","title":"Coda.Behaviour.Analytics.dataframe/0","type":"type"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#t:digest/0","title":"Coda.Behaviour.Analytics.digest/0","type":"type"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#t:facet_type/0","title":"Coda.Behaviour.Analytics.facet_type/0","type":"type"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#t:facets/0","title":"Coda.Behaviour.Analytics.facets/0","type":"type"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#t:facets_analytics_response/0","title":"Coda.Behaviour.Analytics.facets_analytics_response/0","type":"type"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#t:options/0","title":"Coda.Behaviour.Analytics.options/0","type":"type"},{"doc":"","ref":"Coda.Behaviour.Analytics.html#t:scrobbles/0","title":"Coda.Behaviour.Analytics.scrobbles/0","type":"type"},{"doc":"Behaviour of analytics Livebook.","ref":"Coda.Behaviour.Livebook.html","title":"Coda.Behaviour.Livebook","type":"behaviour"},{"doc":"","ref":"Coda.Behaviour.Livebook.html#c:overview/1","title":"Coda.Behaviour.Livebook.overview/1","type":"callback"},{"doc":"","ref":"Coda.Behaviour.Livebook.html#c:render_facets/2","title":"Coda.Behaviour.Livebook.render_facets/2","type":"callback"},{"doc":"","ref":"Coda.Behaviour.Livebook.html#t:digest/0","title":"Coda.Behaviour.Livebook.digest/0","type":"type"},{"doc":"","ref":"Coda.Behaviour.Livebook.html#t:facets/0","title":"Coda.Behaviour.Livebook.facets/0","type":"type"},{"doc":"","ref":"Coda.Behaviour.Livebook.html#t:kino_ui/0","title":"Coda.Behaviour.Livebook.kino_ui/0","type":"type"},{"doc":"","ref":"Coda.Behaviour.Livebook.html#t:options/0","title":"Coda.Behaviour.Livebook.options/0","type":"type"},{"doc":"Render on this day analytics in Livebook.","ref":"Coda.OnThisDay.html","title":"Coda.OnThisDay","type":"module"},{"doc":"","ref":"Coda.OnThisDay.html#render_most_played/1","title":"Coda.OnThisDay.render_most_played/1","type":"function"},{"doc":"","ref":"Coda.OnThisDay.html#render_overview/1","title":"Coda.OnThisDay.render_overview/1","type":"function"},{"doc":"# Coda: music listening history [![Build Status](https://github.com/boonious/coda/actions/workflows/elixir.yml/badge.svg)](https://github.com/boonious/coda/actions/workflows/elixir.yml) [![Hex pm](http://img.shields.io/hexpm/v/coda.svg?style=flat)](https://hex.pm/packages/coda)\n\nAnalytics and visualisation of music listening history 听歌历史.\n\n`coda` currently works with Last.fm columnar data extracted by\n[lastfm_archive](https://github.com/boonious/lastfm_archive). See:\n[Creating a file archive](https://github.com/boonious/lastfm_archive#livebook-guides).\n\nSee [on this day ♫](#livebook) analytics Livebook.","ref":"readme.html","title":"Coda: music listening history","type":"extras"},{"doc":"For now, you can deploy and use the tool in [Livebook](https://livebook.dev) while\nan analytics API and functionality are being refactored and developed.\n\n#","ref":"readme.html#usage","title":"Usage - Coda: music listening history","type":"extras"},{"doc":"[On this day ♫](https://hexdocs.pm/coda/on_this_day.html) presents\nanalytics of all music discovered and played on this day (today) over the years. \nThe page also features an interactive [Kino explorer](https://hexdocs.pm/kino_explorer/Kino.Explorer.html)\nto help delving into the data.\n\n[![Run in Livebook](https://livebook.dev/badge/v1/blue.svg)](https://livebook.dev/run?url=https%3A%2F%2Fraw.githubusercontent.com%2Fboonious%2Fcoda%2Fmaster%2Flivebook%2Fon_this_day.livemd)\n\n![on this day most played analytics](assets/img/livebook_on_this_day_most_played_analytics.png)","ref":"readme.html#livebook","title":"Livebook - Coda: music listening history","type":"extras"},{"doc":"This tool requires Elixir and Erlang (see [installation](https://elixir-lang.org/install.html) details\nfor various operating systems) or [Livebook](https://livebook.dev).","ref":"readme.html#requirement","title":"Requirement - Coda: music listening history","type":"extras"},{"doc":"`coda` is [available in Hex](https://hex.pm/packages/coda),\nthe package can be installed by adding `coda`\nto your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:coda, \"~> 0.2\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at [https://hexdocs.pm/coda](https://hexdocs.pm/coda).","ref":"readme.html#installation","title":"Installation - Coda: music listening history","type":"extras"},{"doc":"Add the following `lastfm_archive` config in `config/config.exs`:\n\n```elixir\n  config :lastfm_archive,\n    user: \"lastfm_user\", # Lastfm user\n    data_dir: \"./lastfm_data/\", # directory containing Lastfm file data,\n```","ref":"readme.html#configuration","title":"Configuration - Coda: music listening history","type":"extras"},{"doc":"# Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"* faster (optimised) on-this-day data frame creation functions and Livebook UX\n* refactor `Analytics`, `Livebook` behaviours and default implementation\n* refactor Livebook rendering functions\n* introduce `ExMachina` test data factory with 200 test track samples","ref":"changelog.html#0-2-0-2023-09-13","title":"0.2.0 (2023-09-13) - Changelog","type":"extras"},{"doc":"* initial commits: on-this-day and common analytics features migrated from [lastfm_archive 0.11.1](https://github.com/boonious/lastfm_archive/blob/master/CHANGELOG.md#0111-2023-08-21)\n* on-this-day Livebook, faceted datasets concept, see [lastfm archive #33](https://github.com/boonious/lastfm_archive/pull/33)","ref":"changelog.html#0-1-0-2023-09-01","title":"0.1.0 (2023-09-01) - Changelog","type":"extras"},{"doc":"# On this day ♫\n\n```elixir\nMix.install(\n  [{:coda, \"~> 0.2\"}, {:kino_explorer, \"~> 0.1.8\"}],\n  config: [\n    lastfm_archive: [\n      data_dir: \"./lastfm_data/\",\n      user: \"\"\n    ]\n  ]\n)\n\nalias Coda.OnThisDay\ndataframe = Coda.Analytics.OnThisDay.dataframe()\n\n:ok\n```","ref":"on_this_day.html","title":"On this day ♫","type":"extras"},{"doc":"Analytics of all music played on this day, today in this past. This Livebook is based on data created by [lastfm_archive](https://github.com/boonious/lastfm_archive).\n\n#","ref":"on_this_day.html#introduction","title":"Introduction - On this day ♫","type":"extras"},{"doc":"* [Columnar data transforms](https://hexdocs.pm/lastfm_archive/transforming.html): please create an archive suitable for analytics workloads, in Apache Arrow format, i.e. transform with `format: :ipc_stream` option\n\n#","ref":"on_this_day.html#prerequisite","title":"Prerequisite - On this day ♫","type":"extras"},{"doc":"* [install](https://livebook.dev/#install) and run this Livebook\n* configure this guide as instructued below, click on `Notebook dependencies and setup`, `Setup` (above)\n\n#","ref":"on_this_day.html#requirement","title":"Requirement - On this day ♫","type":"extras"},{"doc":"`lastfm_archive` has been configured as a dependency in `Setup` above, modify the following config:\n\n* **`user`**: add your Lastfm username or share it via a `LFM_USER` secret (see [Secrets management](https://hackmd.io/@hugobarauna/By6ulTnMi#Secret-management))","ref":"on_this_day.html#configuration","title":"Configuration - On this day ♫","type":"extras"},{"doc":"```elixir\ndataframe\n|> tap(fn df -> OnThisDay.render_overview(df) |> Kino.render() end)\n|> OnThisDay.render_most_played()\n```","ref":"on_this_day.html#most-played","title":"Most played - On this day ♫","type":"extras"},{"doc":"In due course, further analytics and visualisation will be presented. These include newly discovered and most frequently played music on this day over the years. Meanwhile you can interactively delve into the data using [Kino explorer](https://hexdocs.pm/kino_explorer/Kino.Explorer.html) below.\n\n \n\n```elixir\nrequire Explorer.DataFrame\n\ndataframe\n|> Explorer.DataFrame.to_lazy()\n|> Explorer.DataFrame.group_by([\"track\", \"artist\", \"album\"])\n|> Explorer.DataFrame.summarise(id_count: count(id))\n|> Explorer.DataFrame.arrange(desc: id_count)\n|> Explorer.DataFrame.collect()\n```","ref":"on_this_day.html#explore-the-data","title":"Explore the data - On this day ♫","type":"extras"}]}